
#include <stdio.h>

#define MAX 6


int v[MAX] = { 7, 3, 10, 2, 5, 1 };

/*
Aqui, cada funcao devolve um inteiro que e':

	< 0 se a e b estao em ordem	 (i.e., se a<b do ponto de vista ascendente)
	==0 se a e b sao iguais
	> 0 se a e b estao fora de ordem (i.e., se a>b do ponto de vista ascendente)
*/

int ascendente( int a, int b )
{
	return a - b;
}


int descendente( int a, int b )
{
	return b - a;
}


void bubblesort( int v[], int tam, int (*ordem)(int, int) )
{
	int i, j, t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( (*ordem)(v[j], v[j+1]) > 0 )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


int main()
{
	int i;

	bubblesort( v, MAX, ascendente );
	for( i=0; i<MAX; i++ )
		printf( "%d  ", v[i] );
	printf( "\n" );
	bubblesort( v, MAX, descendente );
	for( i=0; i<MAX; i++ )
		printf( "%d  ", v[i] );
	printf( "\n" );
	return 0;
}
