
#include <stdio.h>

#define MAX 10


char v[MAX] = { 'a', 'b', 'Z', 'c', '#', '1', 'B', '!', 'C', '2' };


int grupo( char a )
{
	if( a >= 'A'  &&  a <= 'Z' )
		return 1;
	if( a >= 'a'  &&  a <= 'z' )
		return 2;
	if( a >= '0'  &&  a <= '9' )
		return 3;
	return 4;
}


int compara( char a, char b )
{
	int grp_a, grp_b;

	grp_a = grupo( a );
	grp_b = grupo( b );

	if( grp_a != grp_b )
		return grp_a > grp_b;
	return a > b;
}


void bubblesort( char v[], int tam, int (*fora_de_ordem)(char, char) )
{
	int i, j;
	char t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( (*fora_de_ordem)(v[j], v[j+1]) )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


int main()
{
	int i;

	bubblesort( v, MAX, compara );
	for( i=0; i<MAX; i++ )
		printf( "%c  ", v[i] );
	printf( "\n" );
	return 0;
}
