
#include <stdio.h>


#define MAX 16

int vect[MAX] = { 10, 14, 73, 25, 23, 13, 27, 94, 33, 39, 25, 59, 94, 65, 82, 45 };


void imprimir( int v[], int tam, int pivot )
{
	int i;

	for( i = 0;  i < tam;  i++ )
		{
		printf( " " );
		if( i == pivot )
			printf( "(" );
		printf( "%d", v[i] );
		if( i == pivot )
			printf( ")" );
		}
	printf( "\n" );
}


void troca( int v[], int i, int j )
{
	int tmp;

	tmp = v[i];
	v[i] = v[j];
	v[j] = tmp;
}


void quicksort( int v[], int begin, int end )
{
	int pivot, l, r;

	pivot = v[ (begin+end) / 2 ];
	l = begin;
	r = end;

	for(;;)	{
		while( v[l] < pivot )
			l++;
		while( pivot < v[r] )
			r--;
		if( r <= l )
			break;
		troca( v, l, r );
		l++;
		r--;
		}
	/* aqui, l==r */

	imprimir( v, MAX, l );

	if( begin < --l )  /* se existem elementos 'a esquerda do pivot... */
		quicksort( v, begin, l   );
	if( ++r   < end )  /* se existem elementos 'a direita do pivot... */
		quicksort( v, r,     end );
}


int main()
{
	imprimir( vect, MAX, MAX );
	quicksort( vect, 0, MAX-1 );
	imprimir( vect, MAX, MAX );
	return 0;
}

