
#include <stdio.h>


int vect[] = { 10, 14, 73, 25, 23, 13, 27, 94, 33, 39, 25, 59, 94, 65, 82, 45 };


void imprimir( int v[], int size, int incr )
{
	int i;
	for( i = 0;  i < size;  i++ )
		{
		if( i % incr == 0 )
			printf( "\n" );
		printf( "%d ", v[i] );
		}
	printf( "\n" );
}


void shellsort( int v[], int size )
{
	int i, j, incr, temp;
	incr = size / 2;

	printf( "\nInicio:" );
	imprimir( v, size, size );

	while( incr > 0 )
		{
		printf( "\nAntes:" );
		imprimir( v, size, incr );

		for( i = incr;  i < size;  i++ )
			{
			temp = v[i];
			j = i;
			while( j >= incr  &&  v[j-incr] > temp )
				{
				v[j] = v[j - incr];
				j -= incr;
				}
			v[j] = temp;
			}

		printf( "\nDepois:" );
		imprimir( v, size, incr );

		if( incr == 2 )
			incr = 1;
		else
			incr /= 2.2;
		}

	printf( "\nFim:" );
	imprimir( v, size, size );
}


int main()
{
	shellsort( vect, 16 );
	return 0;
}

