#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


int main()
{
	int x, encontrei, i;
	elemento *p, *ultimo, *temp;

	for(;;)	{
		printf( "Escreva o valor a adicionar 'a cauda da lista\n"
			"(0 para exibir a lista): " );
		scanf( "%d", &x );
		if( x == 0 )
			break;

		p = malloc( sizeof(elemento) );
		if( p == NULL )
			return 1;
		p->valor = x;
		/*
		Acrescentar ao final significa que nao havera' proximo deste
		novo elemento. Mas acrescenta-lo 'a lista agora envolve dois
		casos especiais:
		1: se "primeiro" indica que nao ha' elementos, este elemento
		   sera' o primeiro da lista
		2: caso contrario, temos de percorrer a lista ate' encontrar
		   o ultimo elemento (aquele que nao tem proximo) e no membro
		   "proximo" desse elemento e' que escrevemos o endereco deste
		   novo elemento ("p").
		*/
		p->proximo = NULL;
		if( primeiro == NULL )
			primeiro = p;
		else
			{
			for( ultimo = primeiro;  ultimo->proximo != NULL;  ultimo = ultimo->proximo );
			ultimo->proximo = p;
			}
		}

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );

	/* Pesquisar numeros */
	for(;;)	{
		printf( "Escreva o valor a pesquisar na lista\n"
			"(0 para sair): " );
		scanf( "%d", &x );
		if( x == 0 )
			break;
		encontrei = 0;  /* false */
		for( i = 0, p = primeiro;  p != NULL;  i++, p = p->proximo )
			if( x == p->valor )
				{
				printf( "Encontrei-o no endereco %p, posicao %d\n", p, i );
				encontrei = 1;  /* true */
				}
		if( !encontrei )
			printf( "Nao encontrei esse valor.\n" );
		}

	for( p = primeiro;  p != NULL;  p = temp )
		{
		temp = p->proximo;
		free( p );
		}
	primeiro = NULL;

	return 0;
}

