#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


void inserir_cabeca()
{
	int x;
	elemento *p;

	printf( "Escreva o valor a adicionar 'a cabeca da lista: " );
	scanf( "%d", &x );

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = x;
	p->proximo = primeiro;
	primeiro = p;
}


void inserir_cauda()
{
	int x;
	elemento *p, *p2;

	printf( "Escreva o valor a adicionar 'a cauda da lista: " );
	scanf( "%d", &x );

	p = malloc( sizeof(elemento) );
	if( p == NULL )
		return;
	p->valor = x;
	p->proximo = NULL;


	if( primeiro == NULL )
		primeiro = p;
	else
		{
		for( p2 = primeiro;  p2->proximo != NULL;  p2 = p2->proximo );
		p2->proximo = p;
		}
}


void remover_cabeca()
{
	elemento *tmp;

	if( primeiro != NULL )
		{
		tmp = primeiro;
		primeiro = primeiro->proximo;
		free( tmp );
		}
}


void remover_cauda()
{
	elemento *tmp, *p2;

	if( primeiro != NULL )
		{
		if( primeiro->proximo == NULL )
			{
			tmp = primeiro;
			primeiro = NULL;
			free( tmp );
			}
		else
			{
			for( p2 = primeiro;  p2->proximo->proximo != NULL;  p2 = p2->proximo );
			tmp = p2->proximo;
			p2->proximo = NULL;
			free( tmp );
			}
		}
}


void pesquisar()
{
	int x, i;
	elemento *p;

	printf( "Escreva o valor a pesquisar: " );
	scanf( "%d", &x );

	for( p = primeiro, i = 0;  p != NULL;  p = p->proximo, i++ )
		if( p->valor == x )
			printf( "Encontrei na posicao %d\n", i );
}


void exibir()
{
	elemento *p;

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );
}


int main()
{
	int opcao;

	for(;;)	{
		printf(	"\n\nSeleccione a opcao"
			"\n1 - Inserir 'a cabeca"
			"\n2 - Inserir 'a cauda"
			"\n3 - Remover a cabeca"
			"\n4 - Remover a cauda"
			"\n5 - Pesquisar"
			"\n6 - Exibir\n" );
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:
				inserir_cabeca();
				break;
			case 2:
				inserir_cauda();
				break;
			case 3:
				remover_cabeca();
				break;
			case 4:
				remover_cauda();
				break;
			case 5:
				pesquisar();
				break;
			case 6:
				exibir();
				break;
			}
		}
}
