#include <stdio.h>
#include <string.h>

#define MAX 6

struct aluno
	{
	int numero;
	char nome[60];
	};

typedef struct aluno ALUNO;

ALUNO pauta[MAX] = {
	{ 25213, "Jose Maria"	  },
	{ 25214, "Maria Jose"	  },
	{ 25132, "Antonio Silva"  },
	{  9427, "Zuzarte Gaspar" },
	{ 26200, "Dalia Antunes"  },
	{ 24002, "Jose Soares"	  }
	};


int numCres( ALUNO a, ALUNO b )
{
	return a.numero < b.numero;
}


int numDecr( ALUNO a, ALUNO b )
{
	return a.numero > b.numero;
}


int nomeCres( ALUNO a, ALUNO b )
{
	return strcmp(a.nome, b.nome) < 0;
}


int nomeDecr( ALUNO a, ALUNO b )
{
	if( strcmp(a.nome, b.nome) > 0 )
		return 1;
	else
		return 0;
}


void bubblesort( ALUNO v[], int tam, int (*em_ordem)(ALUNO,ALUNO) )
{
	int i, j;
	ALUNO t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( !(*em_ordem)(v[j],v[j+1]) )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


void imprimir( ALUNO v[], int tam )
{
	int i;

	for( i=0; i<tam; i++ ) 
		printf( "%d - %s\n", v[i].numero, v[i].nome );
}


int main()
{
	int opcao;

	for(;;)	{
		printf(	"\n\nSeleccione a opcao"
			"\n1 - Ordenar por nome por ordem crescente"
			"\n2 - Ordenar por nome por ordem decrescente"
			"\n3 - Ordenar por numero por ordem crescente"
			"\n4 - Ordenar por numero por ordem decrescente"
			"\n5 - Imprimir"
			"\n6 - Sair\n" );
		scanf( "%d", &opcao );
		switch( opcao )
			{
			case 1:
				bubblesort( pauta, MAX, nomeCres );
				break;
			case 2:
				bubblesort( pauta, MAX, nomeDecr );
				break;
			case 3:
				bubblesort( pauta, MAX, numCres );
				break;
			case 4:
				bubblesort( pauta, MAX, numDecr );
				break;
			case 5:
				imprimir( pauta, MAX );
				break;
			case 6:
				return 0;
			}
		}
}
