#include <stdio.h>
#include <string.h>

#define MAX 7

struct jogador
	{
	char nome[100];
	int pontuacao;
	int pocoes;
	int dragoes;
	};

typedef struct jogador JOGADOR;

JOGADOR tabela[MAX] = {
	{ "Grey Lord",       435,  2, 0 },
	{ "Zas",            6034, 15, 2 },
	{ "Lady Dragon",    6856, 29, 1 },
	{ "Dragon Charm",  15907,  4, 6 },
	{ "Swordmaster",   37002,  0, 0 },
	{ "Lady Marion",    6856, 19, 2 },
	{ "Gandalf",        8906, 38, 0 }
	};


int cmp( JOGADOR a, JOGADOR b )
{
	int magia_a, magia_b;

	magia_a = a.pocoes + a.dragoes*10;
	magia_b = b.pocoes + b.dragoes*10;

	if( magia_a != magia_b )
		return magia_a > magia_b;
	if( a.pontuacao != b.pontuacao )
		return a.pontuacao > b.pontuacao;
	return strcmp(a.nome, b.nome) < 0;
}


void bubblesort( JOGADOR v[], int tam, int (*em_ordem)(JOGADOR,JOGADOR) )
{
	int i, j;
	JOGADOR t;

	for( i=0; i<tam-1; i++ )
		{
		for( j=0; j<tam-1-i; j++ )
			{
			if( !(*em_ordem)(v[j],v[j+1]) )
				{
				t = v[j];
				v[j] = v[j+1];
				v[j+1] = t;
				}
			}
		}
}


int main()
{
	int i;

	bubblesort( tabela, MAX, cmp );
	printf(	"\n                          Nome    Pontuacao  Pocoes  Dragoes" 
		"\n     -------------------------    ---------  ------  -------\n" );
	for( i=0; i<MAX; i++ )
		printf( "%30s    %9d  %6d  %7d\n", tabela[i].nome, tabela[i].pontuacao, tabela[i].pocoes, tabela[i].dragoes );

	return 0;
}
