#include <stdio.h>
#include <stdlib.h>


struct s_elemento
	{
	int valor;
	struct s_elemento *proximo;
	};

typedef struct s_elemento elemento;


elemento *primeiro = NULL;


int main()
{
	int x;
	elemento *p, *temp;

	for(;;)	{
		printf( "Escreva o valor a adicionar 'a cabeca da lista\n"
			"(0 para exibir a lista): " );
		scanf( "%d", &x );
		if( x == 0 )
			break;

		p = malloc( sizeof(elemento) );
		if( p == NULL )
			return 1;
		p->valor = x;
		p->proximo = primeiro;
		primeiro = p;
		/*
		As duas linhas acima sao o que garante que o elemento
		e' adicionado ao inicio (cabeca) da lista. Ve^ se as
		compreendes.
		*/
		}

	/* Elimina a cabeca */
	if( primeiro != NULL )
		{
		temp = primeiro;
		primeiro = primeiro->proximo;
		free( temp );
		}

	/* Elimina a cauda */
	if( primeiro != NULL )
		{
		if( primeiro->proximo != NULL )
			{
			for( p = primeiro;  p->proximo->proximo != NULL;  p = p->proximo );
			free( p->proximo );
			p->proximo = NULL;
			}
		else  /* so' existe 1 elemento na lista! */
			{
			free( primeiro );
			primeiro = NULL;
			}
		}

	for( p = primeiro;  p != NULL;  p = p->proximo )
		printf( "Valor = %d\n", p->valor );

	for( p = primeiro;  p != NULL;  p = temp )
		{
		temp = p->proximo;
		free( p );
		}
	primeiro = NULL;

	return 0;
}

