#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX  10000
int v[MAX];


int pesquisa_binaria( int v[], int tam, int val )
{
	int lim_inf, lim_sup, i;

	lim_inf = 0;
	lim_sup = tam-1;

	do	{
		i = (lim_inf + lim_sup) / 2;
		if( val == v[i] )
			return i;
		if( val < v[i] )
			lim_sup = i - 1;
		else
			lim_inf = i + 1;
		}
		while( lim_inf <= lim_sup );

	return -1;
}


int main( void )
{
	int val, val_max, i;

	/* preenche v[] com numeros inteiros aleatorios em ordem crescente */
	srand( (int) time(NULL) );
	val = 0;
	for( i = 0;  i < MAX;  i++ )
		{
		val += rand() % 5;  /* somo ao valor a colocar no vector um "delta" aleatorio entre 0 e 4 */
		v[i] = val;
		}
	val_max = val;

	/* efectua as pesquisas que o utilizador quiser */
	for(;;)	{
		printf( "Numero a pesquisar (1 a %d; 0 para sair): ", val_max );
		scanf( "%d", &val );
		if( val == 0 )
			break;
		i = pesquisa_binaria( v, MAX, val );
		if( i < 0 )
			printf( "Esse valor nao foi encontrado.\n" );
		else
			printf( "O valor foi encontrado na posicao %d.\n", i );
		}

	return 0;
}
