#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX  6
char *v[MAX] = { "Ana", "Bruno", "Carlos", "Diogo", "Eduarda", "Francisco" };


int pesquisa_binaria( char *v[], int tam, char *val )
{
	int lim_inf, lim_sup, i;

	lim_inf = 0;
	lim_sup = tam-1;

	do	{
		i = (lim_inf + lim_sup) / 2;
		if( strcmp(val, v[i]) == 0 )
			return i;
		if( strcmp(val, v[i]) < 0 )
			lim_sup = i - 1;
		else
			lim_inf = i + 1;
		}
		while( lim_inf <= lim_sup );

	return -1;
}


int main( void )
{
	char val[100];
	int i;

	/* efectua as pesquisas que o utilizador quiser */
	for(;;)	{
		printf( "Nome a pesquisar (* para sair): " );
		scanf( " %99[^\r\n]", val );
		if( strcmp(val, "*") == 0 )
			break;
		i = pesquisa_binaria( v, MAX, val );
		if( i < 0 )
			printf( "Esse nome nao foi encontrado.\n" );
		else
			printf( "O nome foi encontrado na posicao %d.\n", i );
		}

	return 0;
}
