#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TIPO_INT	1
#define TIPO_CHAR	2
#define TIPO_DOUBLE	3

#define MAX_TIPOS	5


struct s_tipos
	{
	int quantidade;
	int tipo_num;
	int tipo_size;
	char *tipo_f;
	};
typedef struct s_tipos tipos;

tipos tipos_dados[MAX_TIPOS];


void exibe( int i, int v, void *p )
{
	if( i >= MAX_TIPOS )
	        return;

	if( v < tipos_dados[i].quantidade-1 )
		exibe( i, v+1, p+tipos_dados[i].tipo_size );
	else
		exibe( i+1, 0, p+tipos_dados[i].tipo_size );

	printf( "%d.o membro, posicao %d: ", i+1, v+1 );
	switch( tipos_dados[i].tipo_num )
		{
		case TIPO_INT:
			printf( "%d\n", *(int*)p );
			break;
		case TIPO_CHAR:
			printf( "%c\n", *(char*)p );
			break;
		case TIPO_DOUBLE:
			printf( "%f\n", *(double*)p );
			break;
		}
}


int main()
{
	int i, v, quantidade, tipo_num, tipo_size, size_total;
	char tipo[100+1], *tipo_f;
	void *dados, *p;

	for( i = 0;  i < MAX_TIPOS; )
		{
		printf( "Tipo de dados para o %d.o membro (numero seguido de int/char/double): ", i+1 );
		scanf( "%d %100s", &quantidade, tipo );
		if( strcmp(tipo, "int") == 0 )
			{
			tipo_num = TIPO_INT;
			tipo_size = sizeof( int );
			tipo_f = "%d";
			}
		else if( strcmp(tipo, "char") == 0 )
			{
			tipo_num = TIPO_CHAR;
			tipo_size = sizeof( char );
			tipo_f = " %c";
			}
		else if( strcmp(tipo, "double") == 0 )
			{
			tipo_num = TIPO_DOUBLE;
			tipo_size = sizeof( double );
			tipo_f = "%lf";
			}
		else
			{
			printf( "Tipo de dados desconhecido!\n" );
			continue;
			}
		if( quantidade < 1  ||  quantidade > 10000 )
			{
			printf( "Quantidade invalida (min 1, max 10000)!\n" );
			continue;
			}
		tipos_dados[i].quantidade = quantidade;
		tipos_dados[i].tipo_num   = tipo_num;
		tipos_dados[i].tipo_size  = tipo_size;
		tipos_dados[i].tipo_f     = tipo_f;
		i++;
		}

	size_total = 0;
	for( i = 0;  i < MAX_TIPOS;  i++ )
		size_total += tipos_dados[i].tipo_size * tipos_dados[i].quantidade;

	dados = malloc( size_total );

	p = dados;
	for( i = 0;  i < MAX_TIPOS;  i++ )
		{
		for( v = 0;  v < tipos_dados[i].quantidade;  v++ )
			{
			printf( "Por favor escreva o %d.o membro, posicao %d: ", i+1, v+1 );
			scanf( tipos_dados[i].tipo_f, p );
			p += tipos_dados[i].tipo_size;
			}
		}

	exibe( 0, 0, dados );

	return 0;
}

